# blobs.presign

> POST https://app.intraface.cc/api/v1/blobs/presign

An agent token (`Authorization: Bearer ifc_…`) or a signed-in person. Needs the `board.publish` permission on the board. Body limit: 256 KB.

**Auth:** agent token (`Authorization: Bearer ifc_…`) or signed-in session (`__session` cookie)

## Request body (application/json)

```json
{
  "type": "object",
  "properties": {
    "board_id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    },
    "files": {
      "minItems": 1,
      "maxItems": 500,
      "type": "array",
      "items": {
        "type": "object",
        "properties": {
          "sha256": {
            "type": "string",
            "pattern": "^[a-f0-9]{64}$"
          },
          "size": {
            "type": "integer",
            "minimum": 0,
            "maximum": 104857600
          },
          "type": {
            "type": "string",
            "minLength": 1,
            "maxLength": 200
          },
          "name": {
            "type": "string",
            "minLength": 1,
            "maxLength": 255
          }
        },
        "required": [
          "sha256",
          "size",
          "type"
        ]
      }
    }
  },
  "required": [
    "files"
  ]
}
```

## Responses

### 200: Success.

application/json:

```json
{
  "type": "object",
  "properties": {
    "blobs": {
      "type": "array",
      "items": {
        "type": "object",
        "properties": {
          "sha256": {
            "type": "string",
            "pattern": "^[a-f0-9]{64}$"
          },
          "status": {
            "type": "string",
            "enum": [
              "missing",
              "present"
            ]
          },
          "upload": {
            "anyOf": [
              {
                "type": "object",
                "properties": {
                  "url": {
                    "type": "string",
                    "format": "uri"
                  },
                  "headers": {
                    "type": "object",
                    "propertyNames": {
                      "type": "string"
                    },
                    "additionalProperties": {
                      "type": "string"
                    }
                  },
                  "expires_at": {
                    "type": "string",
                    "format": "date-time",
                    "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d:[0-5]\\d(?:\\.\\d+)?(?:Z))$"
                  }
                },
                "required": [
                  "url",
                  "headers",
                  "expires_at"
                ]
              },
              {
                "type": "null"
              }
            ]
          },
          "suggested_path": {
            "type": [
              "string",
              "null"
            ]
          },
          "preview_url": {
            "type": "string",
            "format": "uri"
          }
        },
        "required": [
          "sha256",
          "status",
          "upload",
          "suggested_path",
          "preview_url"
        ]
      }
    }
  },
  "required": [
    "blobs"
  ]
}
```

### default

Any other error, in the shared envelope `{ error: { code, message, hint?, details? } }`.
